Я пытаюсь добавить сущности в пространство модели существующего файла .dxf, используя ezdxf. Расположение вставленных объектов полностью отличается от того, что я ожидаю от них.

Для круга я получил координаты местоположения объекта, используя e.dxf.insert, и использовал эту точку в качестве центра круга. Я использовал следующий код:

import ezdxf
dwg = ezdxf.readfile("drainage.dxf")

msp = dwg.modelspace()
dwg.layers.new(name='MyCircles', dxfattribs={'color': 7})

def encircle_entity(e):
    if e.dxftype()=='INSERT':
        circleCenter = e.dxf.insert
        msp.add_circle(circleCenter, 10, dxfattribs={'layer': 'MyCircles'})
        print("Circle entity added")

washBasins = msp.query('*[layer=="WASH BASINS"]')
for e in washBasins:
    encircle_entity(e)

dwg.saveas('encircle.dxf')

Ссылка на файлыageage.dxf (входные) и encircle.dxf (выходные): https: // drive .google.com / открыть ? ID = 1aIhZiuEdClt0warjPPcKiz4XJ7A7QWf_

Это создает круг, но в неправильной позиции.

Где находится источник в файле dxf и источник, который использует ezdxf? Как мне получить правильные позиции всех сущностей, особенно INSERT, LINES и CIRCLES? Как мне разместить свои объекты в нужных позициях в уже существующем dxf-файле, используя ezdxf? Где находятся точки e.dxf.start и e.dxf.end линии относительно координат?

Я думаю, что я что-то упустил в координатах здесь. Пожалуйста, объясните, как работают координаты.

1
Naman Kasliwal 7 Апр 2019 в 01:36

2 ответа

Лучший ответ

Python-версия решения @LeeMac, но без учета OCS:

import ezdxf
from ezdxf.math import Vector

DXFFILE = 'drainage.dxf'
OUTFILE = 'encircle.dxf'

dwg = ezdxf.readfile(DXFFILE)
msp = dwg.modelspace()
dwg.layers.new(name='MyCircles', dxfattribs={'color': 4})


def get_first_circle_center(block_layout):
    block = block_layout.block
    base_point = Vector(block.dxf.base_point)
    circles = block_layout.query('CIRCLE')
    if len(circles):
        circle = circles[0]  # take first circle
        center = Vector(circle.dxf.center)
        return center - base_point
    else:
        return Vector(0, 0, 0)


# block definition to examine
block_layout = dwg.blocks.get('WB')
offset = get_first_circle_center(block_layout)

for e in msp.query('INSERT[name=="WB"]'):
    scale = e.get_dxf_attrib('xscale', 1)  # assume uniform scaling
    _offset = offset.rotate_deg(e.get_dxf_attrib('rotation', 0)) * scale
    location = e.dxf.insert + _offset

    msp.add_circle(center=location, radius=1, dxfattribs={'layer': 'MyCircles'})

dwg.saveas(OUTFILE)
0
mozman 11 Апр 2019 в 04:53

Плоские объекты (например, дуги, окружности, двухмерные полилинии (LWPOLYLINEs), ссылки на блоки (INSERTs) и многие другие) определяются относительно Системы координат объектов (OCS) рассчитывается для плоскости, в которой они проживают.

Эта система координат имеет то же происхождение, что и Мировая система координат (WCS), но векторы осей X и Y вычисляются с использованием Алгоритм произвольной оси для заданного вектора выдавливания или перпендикулярно плоскости, в которой находится плоский объект.

Я вижу, что ваш текущий код генерирует круги в координатах точки вставки всех ссылок на блоки (INSERTs), находящихся на слое WASH BASINS.

Координаты точки вставки каждой ссылки на блок выражаются относительно OCS , рассчитанного с использованием вектора экструзии (группа DXF 210), связанного с ссылкой на блок.

Координаты центральной точки круга также выражаются относительно OCS круга, поэтому, чтобы соответствовать положению ссылки на блок, вам нужно будет предоставить метод add_circle для вектор выдавливания ссылки на блок , чтобы координаты точки вставки и координаты центра выражались относительно той же системы координат .

Следовательно, код должен стать:

def encircle_entity(e):
    if e.dxftype()=='INSERT':
        circleCenter = e.dxf.insert
        msp.add_circle(circleCenter, 10, dxfattribs={'layer': 'MyCircles', 'extrusion': e.dxf.extrusion})
        print("Circle entity added")
1
Lee Mac 9 Апр 2019 в 21:32